commit f3c7cb5fb8ade6eb5583d429cb3e99f6fd5fca61
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Mon Jan 24 21:40:41 2022

    Fortran: optional argument DIM for intrinsics NORM2, PARITY must be scalar
    
    gcc/fortran/ChangeLog:
    
            PR fortran/104212
            * check.c (gfc_check_norm2): Check that optional argument DIM is
            scalar.
            (gfc_check_parity): Likewise.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/104212
            * gfortran.dg/argument_checking_26.f90: New test.
    
    (cherry picked from commit 34e8dafb76240f69c729c11cfc8c8fc4f717bc17)

diff --git a/gcc/fortran/check.c b/gcc/fortran/check.c
index 294e0b3ec5b..6cc64910c84 100644
--- a/gcc/fortran/check.c
+++ b/gcc/fortran/check.c
@@ -4336,6 +4336,9 @@ gfc_check_norm2 (gfc_expr *array, gfc_expr *dim)
   if (!array_check (array, 0))
     return false;
 
+  if (!dim_check (dim, 1, false))
+    return false;
+
   if (!dim_rank_check (dim, array, false))
     return false;
 
@@ -4474,6 +4477,9 @@ gfc_check_parity (gfc_expr *mask, gfc_expr *dim)
   if (!array_check (mask, 0))
     return false;
 
+  if (!dim_check (dim, 1, false))
+    return false;
+
   if (!dim_rank_check (dim, mask, false))
     return false;
 
diff --git a/gcc/testsuite/gfortran.dg/argument_checking_26.f90 b/gcc/testsuite/gfortran.dg/argument_checking_26.f90
new file mode 100644
index 00000000000..2b765c5f866
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/argument_checking_26.f90
@@ -0,0 +1,14 @@
+! { dg-do compile }
+! PR fortran/104212 - ICE in transformational_result
+! Contributed by G.Steinmetz
+
+program p
+  logical, parameter :: a(*,*) = reshape([.true.,.false.], shape=[1,2])
+  real,    parameter :: r(*,*) = reshape([1.,2.], shape=[1,2])
+  print *, parity(a)
+  print *, parity(a, dim=1)
+  print *, parity(a, dim=[1]) ! { dg-error "must be a scalar" }
+  print *, norm2 (r)
+  print *, norm2 (r, dim=1)
+  print *, norm2 (r, dim=[1]) ! { dg-error "must be a scalar" }
+end

